#PAINTBALL LOGIC
#adding tags to the snowballs to make them easier to find and so it wont be tagged again after it's shot
#also setting their snowball ID to their player's ID for kill tracking
execute as @a[tag=!dead] at @s run scoreboard players operation @e[type=minecraft:snowball,distance=..2,tag=!shot,tag=!r_p_nuke,tag=!b_p_nuke] snowballID = @s playerID
execute at @a[team=blue,tag=!dead] run tag @e[type=minecraft:snowball,distance=..2,tag=!r_p,tag=!shot] add b_p
execute at @a[team=red,tag=!dead] run tag @e[type=minecraft:snowball,distance=..2,tag=!b_p,tag=!shot] add r_p
#execute as @a[tag=!dead] at @s run tag @e[type=minecraft:snowball,distance=..2] add shot

#BUFFER ZONE <this prevents some weird things from happening by making the '10 feet or less don't shoot' rule in real paintball a thing (sorta)>
execute as @a[team=blue,tag=!dead,scores={usedSnowball=1..}] at @s if entity @a[team=red,distance=..5,tag=!dead] run function paintball_war:ingame/buffer_zone
execute as @a[team=red,tag=!dead,scores={usedSnowball=1..}] at @s if entity @a[team=blue,distance=..5,tag=!dead] run function paintball_war:ingame/buffer_zone

#Paintball hit logic which only runs if a player has been contacted with a enemy paintball, friendly doesn't count
#This also registers a kill for the player that fragged the person.
execute as @a[team=blue,tag=!dead,tag=!justSpawned] at @s anchored eyes if entity @e[tag=r_p,distance=..1.9] run function paintball_war:killregistery/paintball_hit
execute as @a[team=red,tag=!dead,tag=!justSpawned] at @s anchored eyes if entity @e[tag=b_p,distance=..1.9] run function paintball_war:killregistery/paintball_hit

#Updates the rng for the death messages, there are 10, so the rng starts at 10 and 1 is removed every tick so that the death messages seem to be random when in reality, it is player input that determines it.
execute if score logicController deathMessageRNG matches 1.. run scoreboard players remove logicController deathMessageRNG 1
execute if score logicController deathMessageRNG matches ..1 run scoreboard players set logicController deathMessageRNG 10

#Particle trails for different teams
execute as @e[tag=r_p] at @s run particle minecraft:falling_dust minecraft:red_stained_glass ~ ~ ~ 0.1 0.1 0.1 0.025 1 normal
execute as @e[tag=b_p] at @s run particle minecraft:falling_dust minecraft:blue_stained_glass ~ ~ ~ 0.1 0.1 0.1 0.025 1 normal

#MAIN TIMER
#all of the complex looking stuff is for the timer clicks and special effects when the game is about to end
#remove one from the maintimer every tick, when it reaches 0 it is reset to 20 and a second is taken off
scoreboard players remove logicController mainTimer 1
execute if score logicController mainTimer matches 0 run scoreboard players remove logicController secondsLeft 1
execute if score logicController mainTimer matches 0 run scoreboard players set logicController mainTimer 20

#from ten seconds to 6 dont do clicks for most except 10
execute if score logicController secondsLeft matches 10 run bossbar set minecraft:gametime name [{"text":"Time Remaining: ","color":"red"}, {"score":{"name":"logicController","objective":"secondsLeft"}, "color":"yellow"}, {"text":" seconds","color":"red"}]
execute as @a[tag=inGame] at @s if score logicController secondsLeft matches 10 if score logicController mainTimer matches 20 run function paintball_war:ingame/timer_click
execute if score logicController secondsLeft matches 30 if score logicController mainTimer matches 20 run tellraw @a [{"text":"30 seconds left!","color":"green"}]
execute if score logicController secondsLeft matches 15 if score logicController mainTimer matches 20 run tellraw @a [{"text":"15 seconds left!","color":"yellow"}]
execute if score logicController secondsLeft matches 10 if score logicController mainTimer matches 20 run tellraw @a [{"text":"10 seconds left!","color":"yellow"}]
execute if score logicController secondsLeft matches 1..5 if score logicController mainTimer matches 20 run tellraw @a [{"score":{"name":"logicController","objective":"secondsLeft"}, "color":"yellow"}, {"text":" seconds left!","color":"red"}]
execute if score logicController secondsLeft matches 9 run bossbar set minecraft:gametime name [{"text":"Time Remaining: ","color":"yellow"}, {"score":{"name":"logicController","objective":"secondsLeft"}, "color":"red"}, {"text":" seconds","color":"yellow"}]
execute if score logicController secondsLeft matches 8 run bossbar set minecraft:gametime name [{"text":"Time Remaining: ","color":"red"}, {"score":{"name":"logicController","objective":"secondsLeft"}, "color":"yellow"}, {"text":" seconds","color":"red"}]
execute if score logicController secondsLeft matches 7 run bossbar set minecraft:gametime name [{"text":"Time Remaining: ","color":"yellow"}, {"score":{"name":"logicController","objective":"secondsLeft"}, "color":"red"}, {"text":" seconds","color":"yellow"}]
execute if score logicController secondsLeft matches 6 run bossbar set minecraft:gametime name [{"text":"Time Remaining: ","color":"red"}, {"score":{"name":"logicController","objective":"secondsLeft"}, "color":"yellow"}, {"text":" seconds","color":"red"}]

#from 5 seconds to end game do clicks for every one
execute if score logicController secondsLeft matches 5 run bossbar set minecraft:gametime name [{"text":"Time Remaining: ","color":"yellow"}, {"score":{"name":"logicController","objective":"secondsLeft"}, "color":"red"}, {"text":" seconds","color":"yellow"}]
execute as @a[tag=inGame] at @s if score logicController secondsLeft matches 1..5 if score logicController mainTimer matches 20 run function paintball_war:ingame/timer_click
execute if score logicController secondsLeft matches 4 run bossbar set minecraft:gametime name [{"text":"Time Remaining: ","color":"red"}, {"score":{"name":"logicController","objective":"secondsLeft"}, "color":"yellow"}, {"text":" seconds","color":"red"}]
execute if score logicController secondsLeft matches 3 run bossbar set minecraft:gametime name [{"text":"Time Remaining: ","color":"yellow"}, {"score":{"name":"logicController","objective":"secondsLeft"}, "color":"red"}, {"text":" seconds","color":"yellow"}]
execute if score logicController secondsLeft matches 2 run bossbar set minecraft:gametime name [{"text":"Time Remaining: ","color":"red"}, {"score":{"name":"logicController","objective":"secondsLeft"}, "color":"yellow"}, {"text":" seconds","color":"red"}]
execute if score logicController secondsLeft matches 1 run bossbar set minecraft:gametime name [{"text":"Time Remaining: ","color":"yellow"}, {"score":{"name":"logicController","objective":"secondsLeft"}, "color":"red"}, {"text":" seconds","color":"yellow"}]

#bossbar stuff
bossbar set minecraft:gametime players @a
execute if score logicController secondsLeft matches 11.. run bossbar set minecraft:gametime name [{"text":"Time Remaining: ","color":"yellow"}, {"score":{"name":"logicController","objective":"secondsLeft"}, "color":"red"}, {"text":"s","color":"yellow"}]
execute if score logicController gameOver matches 0 run bossbar set minecraft:gametime visible true
execute store result bossbar minecraft:gametime value run scoreboard players get logicController secondsLeft

#AFTER GAME TIMER
execute if score logicController secondsLeft matches 0 run function paintball_war:ingame/end_game
#this shows a gold armor stand for whoever won
execute if score Red killsOverall > Blue killsOverall if score logicController secondsLeft matches -6 as @a[team=red] run function paintball_war:ingame/show_trophy
execute if score Blue killsOverall > Red killsOverall if score logicController secondsLeft matches -6 as @a[team=blue] run function paintball_war:ingame/show_trophy
execute if score logicController secondsLeft matches -12 run execute as @a[tag=inGame] run team join lobby @s
execute if score logicController secondsLeft matches -12 run execute as @a[tag=inGame] run function paintball_war:hub/back_to_hub

#spawn timer and respawn
execute as @a[scores={spawnTimer=1..},tag=dead] if entity @s if score logicController gameOver matches 0 run scoreboard players remove @s spawnTimer 1
execute as @a[scores={spawnTimer=99},tag=dead] if entity @s if score logicController gameOver matches 0 run tellraw @s [{"text":"Respawning in 5...","color":"red"}]
execute as @a[scores={spawnTimer=99},tag=dead] at @s if score logicController gameOver matches 0 run function paintball_war:ingame/timer_click

execute as @a[scores={spawnTimer=80},tag=dead] if entity @s if score logicController gameOver matches 0 run tellraw @s [{"text":"Respawning in 4...","color":"red"}]
execute as @a[scores={spawnTimer=80},tag=dead] at @s if score logicController gameOver matches 0 run function paintball_war:ingame/timer_click

execute as @a[scores={spawnTimer=60},tag=dead] if entity @s if score logicController gameOver matches 0 run tellraw @s [{"text":"Respawning in 3...","color":"red"}]
execute as @a[scores={spawnTimer=60},tag=dead] at @s if score logicController gameOver matches 0 run function paintball_war:ingame/timer_click

execute as @a[scores={spawnTimer=40},tag=dead] if entity @s if score logicController gameOver matches 0 run tellraw @s [{"text":"Respawning in 2...","color":"red"}]
execute as @a[scores={spawnTimer=40},tag=dead] at @s if score logicController gameOver matches 0 run function paintball_war:ingame/timer_click

execute as @a[scores={spawnTimer=20},tag=dead] if entity @s if score logicController gameOver matches 0 run tellraw @s [{"text":"Respawning in 1...","color":"red"}]
execute as @a[scores={spawnTimer=20},tag=dead] at @s if score logicController gameOver matches 0 run function paintball_war:ingame/timer_click

execute as @a[scores={spawnTimer=0..1},tag=dead] if entity @s if score logicController gameOver matches 0 run function paintball_war:ingame/respawn

#PREVENTING SPAWN KILLING
execute as @a[scores={spawnTimer=1..},tag=justSpawned] if entity @s run scoreboard players remove @s spawnTimer 1
#execute as @a[scores={spawnTimer=1..},tag=justSpawned] if entity @s run effect give @s minecraft:speed
#execute as @a[scores={spawnTimer=..1},tag=justSpawned] if entity @s run effect clear @s minecraft:speed
execute as @a[scores={spawnTimer=..1},tag=justSpawned] if entity @s run tag @s remove justSpawned

#KILLSTREAKS and KILLSTREAK EFFECTS
execute if score logicController gameOver matches 0 as @a[scores={killstreak=3..},tag=!dead] run function paintball_war:ingame/killstreak1
execute if score logicController gameOver matches 0 as @a[scores={killstreak=3..5},tag=!dead] run effect give @s minecraft:speed 999999 0 true 
execute if score logicController gameOver matches 0 as @a[scores={killstreak=3..5},tag=!dead] run effect give @s minecraft:jump_boost 999999 0 true 

execute if score logicController gameOver matches 0 as @a[scores={killstreak=6..,usedEpearl=1..},tag=!dead] run function paintball_war:ingame/killstreak2
execute if score logicController gameOver matches 0 as @a[scores={killstreak=6..8},tag=!dead] run effect give @s minecraft:speed 999999 1 true 
execute if score logicController gameOver matches 0 as @a[scores={killstreak=6..8},tag=!dead] run effect give @s minecraft:jump_boost 999999 1 true 

execute if score logicController gameOver matches 0 as @a[scores={killstreak=9..,usedBow=1..},tag=!dead] run function paintball_war:ingame/killstreak3
#summon snowballs from the arrows outside of the other function
execute as @e[tag=r_arrow,nbt={inGround:1b}] at @s run function paintball_war:ingame/summon_red_nuke
execute as @e[tag=b_arrow,nbt={inGround:1b}] at @s run function paintball_war:ingame/summon_blue_nuke
execute if score logicController gameOver matches 0 as @a[scores={killstreak=9..11},tag=!dead] run effect give @s minecraft:speed 999999 2 true
execute if score logicController gameOver matches 0 as @a[scores={killstreak=9..11},tag=!dead] run effect give @s minecraft:jump_boost 999999 2 true

execute if score logicController gameOver matches 0 as @a[scores={killstreak=12..},tag=!dead] run function paintball_war:ingame/killstreak4
execute if score logicController gameOver matches 0 as @a[scores={killstreak=12..14},tag=!dead] run effect give @s minecraft:speed 999999 3 true 
execute if score logicController gameOver matches 0 as @a[scores={killstreak=12..14},tag=!dead] run effect give @s minecraft:jump_boost 999999 3 true

execute if score logicController gameOver matches 0 as @a[scores={killstreak=15..},tag=!dead] run function paintball_war:ingame/killstreak5
execute if score logicController gameOver matches 0 as @a[scores={killstreak=15..},tag=!dead] run effect give @s minecraft:speed 999999 4 true 
execute if score logicController gameOver matches 0 as @a[scores={killstreak=15..},tag=!dead] run effect give @s minecraft:jump_boost 999999 4 true

#CHECKING FOR USE OF SNOWBALL AND REPLENISH WHEN GONE. This is all timed
#also this will give you a snowball if you don't have one
#this first line plays a marker kind of sound when you throw a snowball
execute if score logicController gameOver matches 0 as @a[scores={usedSnowball=1..}] at @s if score @s paintballTimer = @s fireRate run playsound minecraft:block.lava.pop player @a ~ ~ ~ 1 1.2
execute if score logicController gameOver matches 0 as @a[scores={usedSnowball=1..}] run scoreboard players remove @s paintballTimer 1
#execute if score logicController gameOver matches 0 as @a[scores={usedSnowball=1..,paintballTimer=1..}] run title @s actionbar [[{"text":"Next paintball in ","color":"yellow"}, {"score":{"name":"@s","objective":"paintballTimer"}, "color":"red"}, {"text":" ticks","color":"yellow"}]]
execute if score logicController gameOver matches 0 as @a[scores={usedSnowball=1..,paintballTimer=0},team=blue] run replaceitem entity @s hotbar.0 minecraft:snowball{display:{Name:"{\"text\":\"Blue Paintball\",\"color\":\"blue\"}", Lore:["Insta-kill paintball!"]}, Enchantments:[{id:"minecraft:knockback", lvl:1}]} 1
execute if score logicController gameOver matches 0 as @a[scores={usedSnowball=1..,paintballTimer=0},team=red] run replaceitem entity @s hotbar.0 minecraft:snowball{display:{Name:"{\"text\":\"Red Paintball\",\"color\":\"red\"}", Lore:["Insta-kill paintball!"]}, Enchantments:[{id:"minecraft:knockback", lvl:1}]} 1

execute if score logicController gameOver matches 0 as @a[scores={usedSnowball=1..,paintballTimer=0}] run title @s actionbar ""
#This resets the snowball timer and the usedSnowball score
execute if score logicController gameOver matches 0 as @a[scores={usedSnowball=1..,paintballTimer=0}] run scoreboard players set @s usedSnowball 0
execute if score logicController gameOver matches 0 as @a[scores={paintballTimer=..0}] run scoreboard players operation @s paintballTimer = @s fireRate

execute if score logicController gameOver matches 0 as @a[scores={usedSnowball=0},team=blue] run replaceitem entity @s hotbar.0 minecraft:snowball{display:{Name:"{\"text\":\"Blue Paintball\",\"color\":\"blue\"}", Lore:["Insta-kill paintball!"]}, Enchantments:[{id:"minecraft:knockback", lvl:1}]} 1
execute if score logicController gameOver matches 0 as @a[scores={usedSnowball=0},team=red] run replaceitem entity @s hotbar.0 minecraft:snowball{display:{Name:"{\"text\":\"Red Paintball\",\"color\":\"red\"}", Lore:["Insta-kill paintball!"]}, Enchantments:[{id:"minecraft:knockback", lvl:1}]} 1
kill @e[type=minecraft:item,limit=1,nbt={Item:{id:"minecraft:snowball"}}]

#PREMATURE END GAME
execute as @a[scores={endGame=1..}] run function paintball_war:ingame/end_game_premature

#for tips
execute if score logicController gameOver matches 0 as @a[scores={paintballTimer=..0}] run scoreboard players operation logicController tipTimer += logicController secondsLeft

execute if score logicController gameOver matches 1 run effect clear @a minecraft:nausea

#after killstreaks and everything, THIS IS IMPORTANT, because we have to make absolutely sure all paintballs are tagged as 'shot' otherwise, the game will crash if we have tri-shot and one is not
tag @e[type=minecraft:snowball] add shot
